#include <fstream>
#include <iostream>
#include <cmath>
#include <iomanip>
using namespace std;

int n, i, pas;
int sel[202];
int q[202];
double ds[202];
double aa, bb, cc;
double d[2][202];

struct punct {
    int x, y, d;
}a[202], aux, b[202];

void Citeste();
void Qsort(int,int);
void Hill();
void GasestePunct();
int Semn(punct A, punct B, punct C);
void Coeficienti(punct A, punct B);
void Dinamic();
double Dist(int,int);

int main()
{
    Citeste();
    Hill();    // pt det ordinii corecte de infasurare a nodurilor(imprejmuire a parilor)
    Dinamic();
    return 0;
}

void Citeste()
{
    ifstream fin("mosia.in");
    fin >> n;
    for (i = 1; i <= n; i++)
        fin >> a[i].x >> a[i].y >> a[i].d;
    fin.close();
}

void Hill()
{
    int k;
    Qsort(1, n);  // reetichetare a nodurilor
    q[1] = 1;
    q[2] = 2;
    sel[2] = 1;
  	k = 2;       // varful stivei
	i = 2;       // contor pt puncte
	pas = 1;
	while ( i > 1 )
	{
		GasestePunct();
		if ( i == 0 ) break;
		while ( ( k > 1 ) && ( Semn(a[q[k-1]], a[q[k]], a[i]) == -1 ) )
		{
			sel[q[k]] = 0;
			k--;
		}
		k++;
		q[k] = i;
		sel[i] = 1;
    }
} // acum toate nodurile sunt in stiva, in ordinea de infasurare - o permutare a ordinii initiale

void Qsort(int lf, int rt)
{
	if ( lf < rt )
	{
		int i = lf - 1, j = rt + 1;
		do
		{
			do
			{
				i++;
			} while ( a[i].y < a[lf].y || ( a[i].y == a[lf].y && a[i].x < a[lf].x ) );
			do
			{
				j--;
			} while ( a[j].y > a[lf].y || ( a[j].y == a[lf].y && a[j].x > a[lf].x ) );
			if ( i < j )
			{
				aux = a[i];
				a[i] = a[j];
				a[j] = aux;
			}
		} while ( i < j );
		Qsort(lf, j);
		Qsort(j + 1, rt);
	}
}

void GasestePunct()
{
	while ( sel[i] )
	{
	    i += pas;
        if (i == n) pas = -1; //daca am ajuns in elementul cu ordonata cea mai mare, ne intoarcem
    }
}

int Semn(punct A, punct B, punct C)
{
	Coeficienti(A, B);                   // calculeaza coeficientii dreptei care trece prin punctele A si B
	if ( aa * C.x + bb * C.y + cc < 0 )  // daca cele 3 puncte sunt coliniare se ia doar segmentul
		return -1;                       // cel mai lung. Pt a lua doua segmnete se pune "<" in loc de "<="
	return 1;
}

void Coeficienti(punct A, punct B)
{
	aa = A.y - B.y;
	bb = B.x - A.x;
	cc = A.x * B.y - B.x * A.y;
}

double Dist(int i1,int i2)
{
    return sqrt (double ( (b[i1].x - b[i2].x) * (b[i1].x - b[i2].x) + (b[i1].y - b[i2].y) * (b[i1].y - b[i2].y) ) );
}


void Dinamic()
{
    for (i = 1; i <= n; i++)
        b[i] = a[q[i]];
    b[0] = b[n];
    b[n+1] = b[1];        // b[] retine punctele in ordinea corecta (trigonometrica)

    for (i = 1; i <= n; i++)
        ds[i] = (b[i].d  *  Dist(i - 1, i + 1)) / 2;

    d[0][1] = 0;                              // daca nu mutam primul par
    for (i = 2; i <= n; i++)
    {
        if (d[0][i-1] < d[0][i-2] + ds[i])    // mutam parul i
            d[0][i] = d[0][i-2] + ds[i];
        else                                  // nu mutam parul i
            d[0][i] = d[0][i-1];
    }

    d[1][1] = ds[1];                          //mutam primul par
    for (i = 2; i < n; i++)
    {
        if (d[1][i-1] < d[1][i-2] + ds[i])    //mutam parul i
            d[1][i] = d[1][i-2] + ds[i];
        else                                //nu mutam parul i
            d[1][i] = d[1][i-1];
    }
/*
    for (i = 2; i < n; i++)
	{
		d[1][i] = d[1][i-1];
		if (d[1][i] < d[1][i-2] + ds[i])    //mutam parul i
	        d[1][i] = d[1][i-2] + ds[i];

	}
*/

    d[1][n] = d[1][n-1];                      //ultimul par nu mai poate fi mutat pentru ca l-am mutat pe primul

    ofstream fout("mosia.out");
    if (d[1][n] >= d[0][n]) fout << fixed << setprecision(4) << d[1][n];
    else fout << fixed << setprecision(4) << d[0][n];
    fout << '\n';
    fout.close();
}

